	include	whdload.i
	include	whdmacros.i

; ====== Header ======
_base		SLAVE_HEADER				;ws_Security + ws_ID
		dc.w	17				;ws_Version
		dc.w	WHDLF_NoError            	;ws_flags
		dc.l	512*1024                        ;ws_BaseMemSize
		dc.l	0				;ws_ExecInstall
		dc.w	start-_base			;ws_GameLoader
		dc.w	0				;ws_CurrentDir
		dc.w	0				;ws_DontCache
_keydebug	dc.b	0				;ws_keydebug
_keyexit	dc.b	$59				;ws_keyexit = F10
_expmem		dc.l	0                          	;ws_ExpMem
		dc.w	_name-_base			;ws_name
		dc.w	_copy-_base			;ws_copy
		dc.w	_info-_base			;ws_info
		dc.w    0    				;kickstart name
		dc.l    $0      			;kicksize
		dc.w    $0      			;kickcrc
    		dc.w    _config-_base
_config
		dc.b	0
_name	dc.b	"WHDLoad Example",0
_copy	dc.b	"2024 paraj",0
_info	dc.b	"Fixed by you",10
        dc.b    "Version 1.0",10
	dc.b	0


; ====== Slave ======

LOADDR=$40000

start   ;A0 = resident loader
        move.l  a0,a2
	lea	_resload(pc),a0
	move.l	a2,(a0)

        ; Read in boot sector

        moveq   #0,d0           ; offset (in bytes)
        move.l  #1024,d1        ; size (in bytes)
        moveq   #1,d2           ; disk number
        move.l  #LOADDR,a0      ; destination address
        jsr     resload_DiskLoad(a2)

        ; Here's some things you may want

        ;blitz

        ;pea     TDREASON_OK
        ;move.l  _resload(pc),a0
        ;jmp     resload_Abort(a0)

        ; A simple patch list
        lea     pl_boot(pc),a0
        move.l  #LOADDR,a1
        jsr     resload_Patch(a2)

        tst.b   $100.w
        jmp     LOADDR+12

pl_boot PL_START
        PL_NOP  $10,4
        PL_S    $16,12
        ;PL_PS   $44,some_function ; maybe you want to do something different, but remember the patch takes up 6 bytes..
        PL_END

some_function
        rts

_resload:
        ds.l    1
